/**
 * Imports
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _virtex = require('virtex');

var _setAttribute = require('./setAttribute');

var _setAttribute2 = _interopRequireDefault(_setAttribute);

var _removeAttribute = require('./removeAttribute');

var _removeAttribute2 = _interopRequireDefault(_removeAttribute);

var _createElement = require('./createElement');

var _createElement2 = _interopRequireDefault(_createElement);

/**
 * Virtex DOM effects driver
 */

function dom(doc) {
  return function (next) {
    return function (action) {
      switch (type) {
        case _virtex.types.CREATE_TEXT_NODE:
          return doc.createTextNode(payload);
        case _virtex.types.CREATE_ELEMENT:
          return (0, _createElement2['default'])(payload.tag, payload.attrs, payload.children);
        case _virtex.types.SET_ATTRIBUTE:
          return (0, _setAttribute2['default'])(payload.node, payload.name, payload.value);
        case _virtex.types.REMOVE_ATTRIBUTE:
          return (0, _removeAttribute2['default'])(payload.node, payload.name, payload.priorValue);
        case _virtex.types.APPEND_CHILD:
          return payload.node.appendChild(payload.childNode);
        case _virtex.types.REPLACE_CHILD:
          return payload.node.replaceChild(payload.newChild, payload.oldChild);
        case _virtex.types.REMOVE_CHILD:
          return payload.node.removeChild(payload.childNode);
        default:
          return next(action);
      }
    };
  };
}

/**
 * Exports
 */

exports['default'] = dom;
module.exports = exports['default'];