/**
 * Set an attribute on an element
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
function setAttribute(node, name, value) {
  if (typeof value === 'function') {
    value = value(node, name, false);
  }

  if (value === undefined) {
    return;
  }

  switch (name) {
    case 'nodeValue':
    case 'checked':
    case 'disabled':
    case 'selected':
    case 'value':
      node[name] = value;
      break;
    default:
      node.setAttribute(name, value);
  }
}

/**
 * Exports
 */

exports['default'] = setAttribute;
module.exports = exports['default'];